@if (componentData$ | async; as componentData) {
  @if (projectsData$ | async; as projectData) {
    @if (infoLists$ | async; as infoLists) {
      <div class="full-width full-height" sqtmCoreAnchorResize>
        <div
          class="full-width full-height p-r-15"
          style="overflow-y: auto"
          sqtmCoreAnchorScroll
        >
          <nz-collapse [nzBordered]="false" class="entity-view-collapse-panel">
            <nz-collapse-panel
              [sqtmCoreAnchorPanel]="'chart'"
              [sqtmCoreAnchorCollapsePanel]="'chart'"
              [nzHeader]="chartTitle"
              class="anchor"
            >
              <ng-template #chartTitle>
                <div
                  class="flex-row full-width"
                  style="justify-content: space-between; overflow: hidden"
                >
                  <div
                    class="entity-view-collapse-panel-title flex-fixed-size m-r-10"
                  >
                    {{ 'sqtm-core.entity.chart-definition.label' | translate }}
                  </div>
                  <div
                    class="txt-ellipsis m-r-10 m-t-2 generated-label label-color"
                    nz-tooltip
                    [sqtmCoreLabelTooltip]="
                      getGeneratedOnDisplayValue(
                        componentData.chartDefinition.generatedOn
                      )
                    "
                  >
                    {{
                      getGeneratedOnDisplayValue(
                        componentData.chartDefinition.generatedOn
                      )
                    }}
                  </div>
                  <span class="flex-fixed-size" (click)="refreshStats($event)">
                    <i
                      nz-icon
                      nzType="sqtm-core-generic:refresh"
                      nzTheme="outline"
                      nz-tooltip
                      [nzTooltipTitle]="
                        'sqtm-core.generic.label.refresh'
                          | translate
                          | capitalize
                      "
                      class="current-workspace-button action-icon-size"
                      [attr.data-test-toolbar-button-id]="'refresh'"
                    >
                    </i>
                  </span>
                  <sqtm-core-toggle-icon
                    class="flex-fixed-size m-l-5"
                    (clickedInActiveMode)="
                      modifyChart(
                        $event,
                        componentData.chartDefinition.customReportLibraryNodeId
                      )
                    "
                    [stopPropagation]="true"
                    [active]="componentData.permissions.canWrite"
                  >
                    <i
                      nz-icon
                      nzType="sqtm-core-generic:edit"
                      nzTheme="outline"
                      nz-tooltip
                      [nzTooltipTitle]="
                        'sqtm-core.generic.label.modify'
                          | translate
                          | capitalize
                      "
                      class="action-icon-size"
                      [attr.data-test-toolbar-button-id]="'modify'"
                    >
                    </i>
                  </sqtm-core-toggle-icon>
                  <sqtm-core-toggle-icon
                    class="flex-fixed-size m-l-5"
                    (clickedInActiveMode)="downloadChart($event)"
                    [stopPropagation]="true"
                    [active]="componentData.permissions.canExport"
                  >
                    <i
                      nz-icon
                      nzType="sqtm-core-generic:download"
                      nzTheme="outline"
                      nz-tooltip
                      [nzTooltipTitle]="
                        'sqtm-core.generic.label.download'
                          | translate
                          | capitalize
                      "
                      class="action-icon-size"
                      [attr.data-test-toolbar-button-id]="'download'"
                    >
                    </i>
                  </sqtm-core-toggle-icon>
                </div>
              </ng-template>
              <div class="full-width" style="height: 700px">
                <sqtm-app-custom-chart
                  [chartDefinition]="componentData.chartDefinition"
                ></sqtm-app-custom-chart>
              </div>
            </nz-collapse-panel>
            <nz-collapse-panel
              [sqtmCoreAnchorPanel]="'information'"
              [sqtmCoreAnchorCollapsePanel]="'information'"
              sqtmCoreAnchorLastPanel
              [nzHeader]="informationTitle"
              class="anchor"
            >
              <ng-template #informationTitle>
                <div class="entity-view-collapse-panel-title">
                  {{
                    'sqtm-core.test-case-workspace.title.information'
                      | translate
                  }}
                </div>
              </ng-template>
              <div class="creation-modification-grid-container">
                <div class="creation-modification-grid-half-left">
                  <sqtm-core-label
                    [text]="
                      'sqtm-core.entity.generic.creation.label' | translate
                    "
                  >
                  </sqtm-core-label>
                  <div [attr.data-test-field-id]="'chart-definition-created'">
                    <span
                      class="text-ellipsis"
                      nz-tooltip
                      [sqtmCoreLabelTooltip]="
                        getAuditableText(
                          componentData.chartDefinition.createdOn,
                          componentData.chartDefinition.createdBy
                        )
                      "
                    >
                      {{
                        getAuditableText(
                          componentData.chartDefinition.createdOn,
                          componentData.chartDefinition.createdBy
                        )
                      }}</span
                    >
                  </div>
                </div>
                <div class="creation-modification-grid-half-right">
                  <sqtm-core-label
                    [text]="
                      'sqtm-core.entity.generic.modification.label' | translate
                    "
                  >
                  </sqtm-core-label>
                  <div
                    [attr.data-test-field-id]="'chart-definition-lastModified'"
                  >
                    <span
                      class="text-ellipsis"
                      nz-tooltip
                      [sqtmCoreLabelTooltip]="
                        getAuditableText(
                          componentData.chartDefinition.lastModifiedOn,
                          componentData.chartDefinition.lastModifiedBy
                        )
                      "
                      >{{
                        getAuditableText(
                          componentData.chartDefinition.lastModifiedOn,
                          componentData.chartDefinition.lastModifiedBy
                        )
                      }}</span
                    >
                  </div>
                </div>
              </div>
              <div class="information-grid">
                <sqtm-core-label
                  [text]="
                    'sqtm-core.custom-report-workspace.chart.perimeter.label'
                      | translate
                  "
                >
                </sqtm-core-label>
                <div
                  [attr.data-test-field-id]="'perimeter-information'"
                  class="txt-ellipsis"
                  nz-tooltip
                  [sqtmCoreLabelTooltip]="
                    getPerimeterLabel(componentData, projectData)
                  "
                >
                  {{ getPerimeterLabel(componentData, projectData) }}
                </div>
                <sqtm-core-label
                  [text]="
                    'sqtm-core.custom-report-workspace.chart.axis.label'
                      | translate
                  "
                >
                </sqtm-core-label>
                <div>
                  @if (
                    doesMeasureIsRequired(componentData.chartDefinition.type)
                  ) {
                    <div
                      class="axis-information-row"
                      [attr.data-test-element-id]="'measure-information'"
                    >
                      <i
                        class="current-workspace-main-color flex-fixed-size"
                        nz-icon
                        [nzType]="
                          getAxisIcon(
                            componentData.chartDefinition.type,
                            detailedAxisRoles.Measure
                          )
                        "
                        nzTheme="outline"
                      ></i>
                      <span class="m-l-10">{{
                        getAxisI18nKey(detailedAxisRoles.Measure) | translate
                      }}</span>
                      <div
                        class="external-capsule txt-ellipsis"
                        [sqtmCoreWorkspace]="
                          getWorkspace(
                            componentData.chartDefinition.measures[0].column
                          )
                        "
                        [localTheme]="true"
                      >
                        <div
                          class="full-height flex-fixed-size capsule-left-color-indicator"
                          [class.custom-field]="
                            isCuf(componentData.chartDefinition.measures[0])
                          "
                          [style.background-color]="columnPrototypeBorderColor"
                        ></div>
                        <div
                          class="full-height full-width txt-ellipsis inner-capsule"
                        >
                          <div
                            class="m-l-10 m-r-15 txt-ellipsis name"
                            [attr.data-test-field-id]="'measure-information'"
                            nz-tooltip
                            [sqtmCoreLabelTooltip]="
                              getColumnDisplayValue(
                                componentData.chartDefinition.measures[0]
                              ) | async
                            "
                          >
                            {{
                              getColumnDisplayValue(
                                componentData.chartDefinition.measures[0]
                              ) | async
                            }}
                          </div>
                        </div>
                      </div>
                    </div>
                  }
                  <ng-container>
                    <div
                      class="axis-information-row"
                      [attr.data-test-element-id]="'axis-information'"
                    >
                      <i
                        class="current-workspace-main-color flex-fixed-size"
                        nz-icon
                        [nzType]="
                          getAxisIcon(
                            componentData.chartDefinition.type,
                            detailedAxisRoles.Axis
                          )
                        "
                        nzTheme="outline"
                      ></i>
                      <span class="m-l-10">{{
                        getAxisI18nKey(detailedAxisRoles.Axis) | translate
                      }}</span>
                      <div
                        class="external-capsule txt-ellipsis"
                        [sqtmCoreWorkspace]="
                          getWorkspace(
                            componentData.chartDefinition.axis[0].column
                          )
                        "
                        [localTheme]="true"
                      >
                        <div
                          class="full-height flex-fixed-size capsule-left-color-indicator"
                          [class.custom-field]="
                            isCuf(componentData.chartDefinition.axis[0])
                          "
                          [style.background-color]="columnPrototypeBorderColor"
                        ></div>
                        <div
                          class="full-height full-width txt-ellipsis inner-capsule"
                        >
                          <div
                            class="m-l-10 m-r-15 txt-ellipsis name"
                            [attr.data-test-field-id]="'axis-information'"
                            nz-tooltip
                            [sqtmCoreLabelTooltip]="
                              getColumnDisplayValue(
                                componentData.chartDefinition.axis[0]
                              ) | async
                            "
                          >
                            {{
                              getColumnDisplayValue(
                                componentData.chartDefinition.axis[0]
                              ) | async
                            }}
                          </div>
                        </div>
                      </div>
                    </div>
                  </ng-container>
                  @if (
                    doesSeriesAreRequired(componentData.chartDefinition.type)
                  ) {
                    <div
                      class="axis-information-row"
                      [attr.data-test-element-id]="'series-information'"
                    >
                      <i
                        class="current-workspace-main-color flex-fixed-size"
                        nz-icon
                        [nzType]="
                          getAxisIcon(
                            componentData.chartDefinition.type,
                            detailedAxisRoles.Series
                          )
                        "
                        nzTheme="outline"
                      ></i>
                      <span class="m-l-10">{{
                        getAxisI18nKey(detailedAxisRoles.Series) | translate
                      }}</span>
                      <div
                        class="external-capsule txt-ellipsis"
                        [sqtmCoreWorkspace]="
                          getWorkspace(
                            componentData.chartDefinition.axis[1].column
                          )
                        "
                        [localTheme]="true"
                      >
                        <div
                          class="full-height flex-fixed-size capsule-left-color-indicator"
                          [class.custom-field]="
                            isCuf(componentData.chartDefinition.axis[1])
                          "
                          [style.background-color]="columnPrototypeBorderColor"
                        ></div>
                        <div
                          class="full-height full-width txt-ellipsis inner-capsule"
                        >
                          <div
                            class="m-l-10 m-r-15 txt-ellipsis name"
                            [attr.data-test-field-id]="'series-information'"
                            nz-tooltip
                            [sqtmCoreLabelTooltip]="
                              getColumnDisplayValue(
                                componentData.chartDefinition.axis[1]
                              ) | async
                            "
                          >
                            {{
                              getColumnDisplayValue(
                                componentData.chartDefinition.axis[1]
                              ) | async
                            }}
                          </div>
                        </div>
                      </div>
                    </div>
                  }
                </div>
                @if (componentData.chartDefinition.filters.length > 0) {
                  <sqtm-core-label
                    [text]="
                      'sqtm-core.custom-report-workspace.chart.filters.name'
                        | translate
                    "
                    [attr.data-test-element-id]="'filters-label'"
                  >
                  </sqtm-core-label>
                }
                @if (componentData.chartDefinition.filters.length > 0) {
                  <div>
                    @for (
                      filter of componentData.chartDefinition.filters;
                      track filter;
                      let index = $index
                    ) {
                      <div
                        class="external-capsule txt-ellipsis"
                        [sqtmCoreWorkspace]="getWorkspace(filter.column)"
                        [localTheme]="true"
                      >
                        <div
                          class="full-height flex-fixed-size capsule-left-color-indicator"
                          [class.custom-field]="isCuf(filter)"
                          [style.background-color]="columnPrototypeBorderColor"
                        ></div>
                        <div
                          class="full-height full-width txt-ellipsis inner-capsule"
                        >
                          <div
                            class="m-l-10 m-r-15 txt-ellipsis name"
                            [attr.data-test-field-id]="
                              'filter-information-' + index
                            "
                            nz-tooltip
                            [sqtmCoreLabelTooltip]="
                              getFilterDisplayValue(filter, infoLists) | async
                            "
                          >
                            {{
                              getFilterDisplayValue(filter, infoLists) | async
                            }}
                          </div>
                        </div>
                      </div>
                    }
                  </div>
                }
              </div>
            </nz-collapse-panel>
            <div id="sqtm-core-ghost-div" sqtmCoreAnchorGhostDiv></div>
          </nz-collapse>
        </div>
      </div>
    }
  }
}
